using System;
using System.Configuration;

namespace k.App.Data
{
    /// <summary>
    /// Summary description for Settings.
    /// </summary>
    public class Settings
    {
        public Settings()
        {
        }

        private static string m_ExternalServerConnString = "";
        public static string ExternalServerConnString
        {
            get { return m_ExternalServerConnString; }
            set { m_ExternalServerConnString = value; }
        }

        private static string m_AppServerConnString = "";
        public static string AppServerConnString
        {
            get { return m_AppServerConnString; }
            set { m_AppServerConnString = value; }
        }
        private static string m_RptServerConnString = "";
        public static string RptServerConnString
        {
            get { return m_RptServerConnString; }
            set { m_RptServerConnString = value; }
        }

        private static int m_ExecutionTimeout = 30;
        public static int ExecutionTimeout
        {
            get { return m_ExecutionTimeout; }
            set { m_ExecutionTimeout = value; }
        }

        #region Statics
        /// <summary>
        /// Static Constructor
        /// </summary>
        static Settings()
        {
            //Settings.GetConnStringFromRegistry();

            Settings.AppServerConnString = "";
            Settings.RptServerConnString = "";
        }

        static void GetConnStringFromRegistry()
        {
            Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE");
            //TODO: 
            string keyName = Settings.GetKeyName();//"Ozcelik";
            Microsoft.Win32.RegistryKey subkey = key.OpenSubKey(keyName);
            object appCnnStr = null;
            object rptCnnStr = null;
            object execTimeout = null;
            try
            {
                appCnnStr = subkey.GetValue("AppServerConnectionString");
                rptCnnStr = subkey.GetValue("ReportServerConnectionString");
                execTimeout = subkey.GetValue("ExecutionTimeout");
            }
            catch (Exception)
            {
                throw new ConnectionStringNotFoundException("HKEY_LOCAL_MACHINE\\SOFTWARE\\" + keyName + " altnda tanml ConnectionString string deer bulunamad..!");
            }
            if (appCnnStr == null || rptCnnStr == null)
            {
                throw new ConnectionStringNotFoundException("HKEY_LOCAL_MACHINE\\SOFTWARE\\" + keyName + " altnda tanml ConnectionString string deer bulunamad..!");
            }
            Settings.AppServerConnString = appCnnStr.ToString();
            Settings.RptServerConnString = rptCnnStr.ToString();
            if (execTimeout != null)
                Settings.ExecutionTimeout = int.Parse(execTimeout.ToString());

        }


        static string GetKeyName()
        {
            char key = '\\';
            if (AppDomain.CurrentDomain.BaseDirectory.LastIndexOf("/") > -1)
            {
                key = '/';
            }
            string[] arr = AppDomain.CurrentDomain.BaseDirectory.Split(key);
            if (arr.Length >= 2)
            {
                if (key == '/')
                {
                    return "Ozcelik\\" + arr[arr.Length - 2] + "\\" + arr[arr.Length - 1];
                }
                else
                {
                    if (arr[arr.Length - 1].Length > 0)
                    {
                        return "Ozcelik\\" + arr[arr.Length - 1];
                    }
                    else
                    {
                        return "Ozcelik\\" + arr[arr.Length - 2];
                    }
                }
            }
            else
            {
                if (arr.Length > 0)
                {
                    return "Ozcelik\\" + arr[0];
                }
                else
                {
                    return "Ozcelik\\" + "Root";
                }
            }

        }
        #endregion


    }
}
