/*
 Ivn Loire - www.dotneat.net
 * 
 * Use it freely for whatever purpose and at your own risk.
 * This example is provided "as it is", with no warranties.
 */
using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.GData.YouTube;
using Google.GData.Extensions.MediaRss;
using Google.YouTube;

public partial class _Default : System.Web.UI.Page 
{

    void printVideoEntry(Video video)
    {
        Response.Write("Title: " + video.Title);
        Response.Write(video.Description);
        Response.Write("Keywords: " + video.Keywords);
        Response.Write("Uploaded by: " + video.Uploader);
        if (video.YouTubeEntry.Location != null)
        {
            Response.Write("Latitude: " + video.YouTubeEntry.Location.Latitude);
            Response.Write("Longitude: " + video.YouTubeEntry.Location.Longitude);
        }
        if (video.Media != null && video.Media.Rating != null)
        {
            Response.Write("Restricted in: " + video.Media.Rating.Country);
        }

        if (video.IsDraft)
        {
            Response.Write("Video is not live.");
            string stateName = video.Status.Name;
            if (stateName == "processing")
            {
                Response.Write("Video is still being processed.");
            }
            else if (stateName == "rejected")
            {
                Console.Write("Video has been rejected because: ");
                Response.Write(video.Status.Value);
                Console.Write("For help visit: ");
                Response.Write(video.Status.Help);
            }
            else if (stateName == "failed")
            {
                Console.Write("Video failed uploading because:");
                Response.Write(video.Status.Value);

                Console.Write("For help visit: ");
                Response.Write(video.Status.Help);
            }

            if (video.ReadOnly == false)
            {
                Response.Write("Video is editable by the current user.");
            }

            if (video.RatingAverage != -1)
            {
                Response.Write("Average rating: " + video.RatingAverage);
            }
            if (video.ViewCount != -1)
            {
                Response.Write("View count: " + video.ViewCount);
            }

            Response.Write("Thumbnails:");
            foreach (MediaThumbnail thumbnail in video.Thumbnails)
            {
                Response.Write("\tThumbnail URL: " + thumbnail.Url);
                Response.Write("\tThumbnail time index: " + thumbnail.Time);
            }

            Response.Write("Media:");
            foreach (Google.GData.YouTube.MediaContent mediaContent in video.Contents)
            {
                Response.Write("\tMedia Location: " + mediaContent.Url);
                Response.Write("\tMedia Type: " + mediaContent.Format);
                Response.Write("\tDuration: " + mediaContent.Duration);
            }
        }

    }
    /// <summary>
    /// Create and returns and Google.GData.Client.AtomFee from url with the specific start and number of items
    /// </summary>
    /// <param name="url"></param>
    /// <param name="start"></param>
    /// <param name="number"></param>
    /// <returns></returns>
    private static AtomFeed GetFeed(string url, int start, int number)
    {
        System.Diagnostics.Trace.Write("Conectando youtube at " + url);
        FeedQuery query = new FeedQuery("");
        Service service = new Service("youtube", "exampleCo");
        query.Uri = new Uri(url);
        query.StartIndex = start;
        query.NumberToRetrieve = number;

        AtomFeed myFeed = service.Query(query);
        return myFeed;
    }


    /// <summary>
    /// Gets html code to display video
    /// </summary>
    /// <param name="id"></param>
    /// <returns></returns>
    private string RenderVideoEmbedded(string id)
    {
        return string.Format("<div id=\"video{0}\"><object width=\"425\" height=\"355\"><param name=\"movie\" value=\"http://www.youtube.com/v/{0}&rel=1\"></param><param name=\"wmode\" value=\"transparent\"></param><embed src=\"http://www.youtube.com/v/{0}&rel=1\" type=\"application/x-shockwave-flash\" wmode=\"transparent\" width=\"425\" height=\"355\"></embed></object></div>", id);
    }

    /// <summary>
    /// Converts URL ID to short one
    /// </summary>
    /// <param name="googleID"></param>
    /// <returns></returns>
    private string getIDSimple(string googleID) { 
        int lastSlash=googleID.LastIndexOf("/");
        return googleID.Substring(lastSlash + 1);                
    }


    /// <summary>
    /// Renders feed in example aspx page
    /// </summary>
    /// <param name="myFeed"></param>
    private void DisplayFeed(AtomFeed myFeed)
    {
        System.Text.StringBuilder sb = new System.Text.StringBuilder();
        foreach (AtomEntry entry in myFeed.Entries)
        {
            #region render each
            sb.Append("<br /><b>Title:</b> ");
            sb.Append(entry.Title.Text);
            sb.Append("<br /><b>Categories:</b> ");            
            foreach (AtomCategory cat in entry.Categories)
            {
                sb.Append(cat.Term);
                sb.Append(",");
            }
            sb.Append(RenderVideoEmbedded(getIDSimple(entry.Id.AbsoluteUri)));
            sb.Append("<br /><b>Published on:</b> ");
            sb.Append(entry.Published);
            #endregion
        }
        this.lblResults.Text = sb.ToString();
    }





    //by tag
    //feel free to change number of items, by there is a limit of 50, I believe. 
    //If you want to retreive more, you have to do a loop (retrieve 1-50, then 51 to 100, etc)
    protected void btoGo_Click(object sender, EventArgs e)
    {
        string url = "http://gdata.youtube.com/feeds/videos/-/" + this.txtTag.Text;
        AtomFeed myFeed = GetFeed(url, 1, 20);
        DisplayFeed(myFeed);        
    }

    //by search
    //feel free to change number of items, by there is a limit of 50, I believe. 
    //If you want to retreive more, you have to do a loop (retrieve 1-50, then 51 to 100, etc)
    protected void btoSearch_Click(object sender, EventArgs e)
    {
        string url = "http://gdata.youtube.com/feeds/videos?q=" + this.txtSearch.Text;
        AtomFeed myFeed = GetFeed(url, 1, 15);
        DisplayFeed(myFeed);
    }

    //by search
    //feel free to change number of items, by there is a limit of 50, I believe. 
    //If you want to retreive more, you have to do a loop (retrieve 1-50, then 51 to 100, etc)
    protected void btoFvList_Click(object sender, EventArgs e)
    {
        YouTubeRequestSettings settings = new YouTubeRequestSettings("TestingForNow",
                                                                     "AI39si7pq5GLrR9QOG-9VcMdpTSjTkGAkIi2KMKPKIH53hIofSy_ggut9LQjh4oW8jnEMutfC8FE_1yMDeEe5FCyxcORzpHZdg",
                                                                     "kadirmustafa@gmail.com",
                                                                     "dobelardoq1a");
        YouTubeRequest request = new YouTubeRequest(settings);

        Feed<Playlist> userPlaylists = request.GetPlaylistsFeed("kadirmo");

        foreach (Playlist p in userPlaylists.Entries)
        {
            Response.Write("Title: " + p.Title +"<br>");
            Response.Write(p.Summary  + "<br>");
            Response.Write("Number of entries: " + p.CountHint + "<br>");

            Feed<PlayListMember> list = request.GetPlaylist(p);
            foreach (PlayListMember v in list.Entries)
            {
                string yt = "http://www.youtube.com/watch?v={0}";
                Response.Write(String.Format(yt,((Google.YouTube.Video)(v)).VideoId) + "<br>");
                //printVideoEntry(v);
                //
            }
        }

    }




}
